
public class Main {
    public static int[] createRandomData(int size) {
        int[] data = new int[size];
        for (int i = 0; i < size; i++) {
            data[i] = (int)(Math.random() * 10000);
        }
        return data;
    }

    private static void check(int[] data) {
        for (int i = 0; i < data.length-1; i++) {
            if (data[i] > data[i+1]) {
                System.out.println("error!");
                System.exit(1);
            }
        }
    }

    public static void main(String[] args) {
        Sorter[] sorters = {
            new BubbleSort(),
            new ShakerSort(),
            new SelectSort(),
            new InsertSort(),
            new HeapSort(),
            new QuickSort(),
            new MergeSort(),
        };
        int [] data;

        for (int i = 0; i < sorters.length; i++) {
            data = createRandomData(50000);
            System.out.println("type.." + sorters[i].getClass().getName());
            long start = System.currentTimeMillis();
            System.out.println("start.." + start);
            sorters[i].sort(data);
            long end = System.currentTimeMillis();
            System.out.println("end.." + end);
            System.out.println("time.." + (end - start));
            check(data);
        }
    }
}
